"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rmdirOrfile = rmdirOrfile;
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
const util_1 = require("./util");
function rmdirOrfile(_path) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!fs_1.default.existsSync(_path))
            return;
        const file = yield (0, util_1.callbackToPromise)(fs_1.default.stat)(_path);
        if (file.isFile()) {
            yield (0, util_1.callbackToPromise)(fs_1.default.rm)(_path);
        }
        else if (file.isDirectory()) {
            const fileDir = yield (0, util_1.callbackToPromise)(fs_1.default.readdir)(_path);
            for (let i = 0; i < fileDir.length; i++) {
                yield rmdirOrfile(path_1.default.join(_path, fileDir[i]));
            }
            yield (0, util_1.callbackToPromise)(fs_1.default.rmdir)(_path);
        }
    });
}
//# sourceMappingURL=del.js.map