#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const inquirer_1 = __importDefault(require("inquirer"));
const handlebars_1 = __importDefault(require("handlebars"));
const del_1 = require("./del");
const commander_1 = require("commander");
const promise_1 = __importDefault(require("git-clone/promise"));
const config_1 = require("./config");
const program = new commander_1.Command();
const { version } = require('../package.json');
program
    .name('npm-init-cli')
    .description('game npm库初始化脚手架')
    .version(version);
program
    .command('init <name>')
    .description('init game project')
    .action((name) => __awaiter(void 0, void 0, void 0, function* () {
    const { isServer } = yield inquirer_1.default.prompt(config_1.initPrompts);
    const clonePath = path_1.default.join(process.cwd(), '');
    yield (0, del_1.rmdirOrfile)(clonePath);
    yield (0, promise_1.default)(config_1.gitPath, clonePath, {
        checkout: !isServer ? 'client_template' : 'server_template'
    });
    (0, del_1.rmdirOrfile)(path_1.default.join(clonePath, '.git'));
    const packagePath = path_1.default.join(clonePath, 'package.json');
    if (fs_1.default.existsSync(packagePath)) {
        const content = fs_1.default.readFileSync(packagePath).toString();
        const template = handlebars_1.default.compile(content);
        const result = template({ name });
        fs_1.default.writeFileSync(packagePath, result);
        console.log('modify package.json complate');
    }
    else {
        throw new Error('no package.json');
    }
}));
program.parse();
//# sourceMappingURL=index.js.map