import path from 'path';
import fs, { Stats } from 'fs';
import { callbackToPromise } from './util'

export async function rmdirOrfile(_path: string) {
    if (!fs.existsSync(_path)) return;
    const file = await callbackToPromise(fs.stat)(_path) as Stats;
    if (file.isFile()) {
        await callbackToPromise(fs.rm)(_path);
    } else if (file.isDirectory()) {
        const fileDir = await callbackToPromise(fs.readdir)(_path) as string[];
        for (let i = 0; i < fileDir.length; i++) {
            await rmdirOrfile(path.join(_path, fileDir[i]))
        }
        await callbackToPromise(fs.rmdir)(_path);
    }
}