
export function callbackToPromise<T extends (...args: any) => any>(fn: T) {
    return function (...args: any) {
        return new Promise((resolve, reject) => {
            fn(...args, (err: any, result: any) => {
                if (err) {
                    reject(err);
                } else {
                    resolve(result);
                }
            });
        });
    };
}